#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <3ds.h>
#include "cecd.h"

int main(int argc, char **argv)
{
	// Initialize services
	srvInit();
	cecdInit();
	gfxInitDefault();

	consoleInit(GFX_TOP, NULL);
	printf("This program will clear the MacFilter__ file\non your console.\n\n");
	printf("This allows you to streetpass other 3DS again\nwithout waiting 8 hours.\n\n");
	printf("Only 1 of the communicating 3DS needs a cleared\nMacFilter to streetpass again with the other one.\n\n");
	printf("For example: If you have 2 3DS you only need\nto clear the MacFilter on one of these consoles.\n");
	printf("If you have 4 3DS and want that all streetpass\nagain you have to clear the Mac Filter on 3 of\nthem\n");
	
	printf("\n\n\n");
	printf("Press \x1b[31mA\x1b[0m to exit\n");
	printf("Press \x1b[32mY\x1b[0m to clear MAC Filter\n");
	printf("Press \x1b[36mX\x1b[0m to clear MAC Filter and exit\n");
	
	consoleInit(GFX_BOTTOM, NULL);
	
	u32 ret = 0;
	u32 out = 0;
	
	if (ret != 0){
		printf("An error occured. Error code: ");
		printf("%lx \n",ret);
		gfxFlushBuffers();
		gfxSwapBuffers();
	}
	
	gfxFlushBuffers();
	gfxSwapBuffers();
	
	while(aptMainLoop()) //Always have the main code loop in here
	{
		gspWaitForVBlank();
		
		hidScanInput(); //Checks which keys are pressed

		u32 button = hidKeysDown(); // Checks which keys are up and which ones are down

		if(button & KEY_A || button & KEY_START) break;
		
		if(button & KEY_Y){
			ret = CECDU_RunCommand(&out, CEC_COMMAND_RESET_FILTER);
			if (ret == 0){
				printf("MAC Filter cleared\n");
				gfxFlushBuffers();
				gfxSwapBuffers();
			} else {
				printf("An error occured. Error code: ");
				printf("%lx \n",ret);
				gfxFlushBuffers();
				gfxSwapBuffers();
			}
		}
		
		if(button & KEY_X) {
			ret = CECDU_RunCommand(&out, CEC_COMMAND_RESET_FILTER);
			if (ret == 0){
				printf("MAC Filter cleared\n");
				gfxFlushBuffers();
				gfxSwapBuffers();
				break;
			}
			printf("An error occured. Error code: ");
			printf("%lx \n",ret);
			gfxFlushBuffers();
			gfxSwapBuffers();
		}
		if(button & KEY_SELECT) {
			ret = CECDU_GetCecStateAbbreviated(&out);
			if (ret == 0){
				printf("Cec State: %li\n", out);
				gfxFlushBuffers();
				gfxSwapBuffers();
			}
		}
	}

	// Exit services
	gfxExit();
	cecdExit();
	srvExit();
	hidExit();
	
	return 0;
}